var Logger = require('Logger');
var registry = {};

module.exports = {
    register: function(name, actionDefinition) {
        registry[name] = actionDefinition;
    },

    construct: function(actionDefinition) {
        if (!actionDefinition || !actionDefinition.name) {
            Logger.warn("No action definition available for Action.construct().");
            return;
        }
        if (!registry[actionDefinition.name]) {
            Logger.warn("No action registered for %s.", actionDefinition.name);
            return;
        }
        var action = registry[actionDefinition.name].apply(null, actionDefinition.params);
        action.name = actionDefinition.name;
        return action;
    }
};
