/*
  A link to a URL generates from a route.
  In contrast to React.DOM.a, this uses DEF.buildUrl to look up
  the correct URL for a given endpoint. Since buildUrl is asynchronous,
  the a tag that we generate begins with an empty href and has its
  href set when available.
*/

var A = React.createClass({
    propTypes: {
        endpoint: React.PropTypes.string.isRequired,
        values: React.PropTypes.objectOf(React.PropTypes.string),
        query: React.PropTypes.objectOf(React.PropTypes.string)
    },

    getInitialState: function() {
        return { href: '' };
    },

    getDefaultProps: function() {
        return { values: {}, query: {} };
    },

    render: function() {
        return <a {...this.props} href={this.state.href}>
            {this.props.children}
        </a>;
    },

    componentWillReceiveProps: function(nextProps) {
        this.setState({ href: '' });
        this._retrieveHref(nextProps);
    },

    componentDidMount: function() {
        this._retrieveHref();
    },

    _retrieveHref: function() {
        var query = { query: this.props.query };
        DEF.buildUrl(this.props.endpoint, this.props.values, query).then(function(href) {
            this.setState({ href: href });
        }.bind(this));
    }
});

module.exports = A;
