/*
  For those times when you need an Observer-ready model but we haven't
  written a better one yet.

  If you ever find yourself thinking "but what if I need to extend from
  this?" something has gone wrong. If you have to do anything more serious
  than modifying a one-off instance, this isn't your solution.
*/
module.exports = Backbone.Model.extend({
    initialize: function() {
        for (var methodName in DEF.Observable) {
            this[methodName] = _.bind(DEF.Observable[methodName], this);
        }
        this.on('change', this.notifyObserversOfChange);
    }
});
