/*
  Mixin of common form field methods
*/
module.exports = {
    preventDefaultOnEnter: function(event) {
        if (event.key == 'Enter') {
            event.preventDefault();
        }
    },

    fieldWasChanged: function(event) {
        var model = this.props.model;
        if (!model || (model && !model.setValueForField)) {
            throw new Error(
                "ABC.FormFieldMethods must be mixed into a component that " +
                "supplies a 'model' prop which defines a method 'setValueForField'" +
                ABC.getDeclarationErrorAddendum(this));
        }
        this.props.model.setValueForField(event.target.name, event.target.value);
    },

    focus: function () {
        if (!this.refs.input) {
            // FIXME:dh expand to other refs or kinds of focus, based on wrapped
            // input type and expected behavior?
            throw new Error(
                "ABC.FormFieldMethods requires a ref of 'input' on " +
                "the field it is focusing" +
                ABC.getDeclarationErrorAddendum(this));
        }
        this.refs.input.getDOMNode().focus();
    }
};
