var I18N = require('../mixins/i18n.js');

/*
    Mixin: some bits that make a FormField a FormField. Everything in this family
    should include these or implement their own.
*/
var FormFieldShell = React.createClass({
    mixins: [I18N],

    errorFor: function(name) {
        var error = this.props.model.errorMessageForFieldNamed(name);
        return error && <span className="error">{error}</span>;
    },

    render: function() {
        return <div disabled={this.props.disabled}>
            <label>{this.props.label}
                <ABC.If test={this.props.optional === true}>
                    <span className="optional">
                        &nbsp;{this.gettext('(Optional)')}
                    </span>
                </ABC.If>
            </label>
            <ABC.If test={!_.isUndefined(this.props.hint)}>
                <p className="hint">{this.props.hint}</p>
            </ABC.If>
            {this.errorFor(this.props.name)}
            {this.props.children}
        </div>;
    }
});

module.exports = FormFieldShell;
