"use strict";

var React = require('react/addons');

/*
  Renders its children if and only if the 'test' prop is truthy.
*/
var If = React.createClass({
    propTypes: {
        test: React.PropTypes.any.isRequired,

        // optionally pass a transition name to use a TransitionGroup.
        transition: React.PropTypes.string
    },

    render: function () {
        if (this.props.transition && this.props.transition.length) {
            var TransitionGroup = React.addons.CSSTransitionGroup;
            return <span className="abc-if">
                <TransitionGroup transitionName={this.props.transition}>
                    {this.props.test ? <span key="0">{this.props.children}</span> : null}
                </TransitionGroup>
            </span>;
        }
        if (this.props.test) {
            return <span className="abc-if">{this.props.children}</span>;
        }
        // render() must return a ReactComponent
        return <span className="abc-if"></span>;
    }
});

module.exports = If;
