'use strict';

var React = require('react');
var _ = require('underscore');

/*
    An ImageUplaoder form widget.
    Currently implemented in terms of uploadcare.

    TODO: Pull out the good parts from uploadcare.js.
*/
var ImageUploader = React.createClass({

    propTypes: {
        name: React.PropTypes.string.isRequired,

        // Image that should show in preview, assumed to be the existing
        // image set on the asset that this uploader is working with.
        existingImage: React.PropTypes.string,

        // Default image to show in preview if 'existingImage' is not given.
        defaultImage: React.PropTypes.string,

        // Called when a new image is uploaded, and is passed the URL
        // (with modifiers) of the new image.
        onChange: React.PropTypes.func.isRequired
    },

    getDefaultProps: function() {
        // FIXME:dh currently only used on org/edit, should probably
        // change when we expand ImageUploader's use elsewhere
        return { defaultImage: '/images/org/noLogo-m.gif' };
    },

    _urlForState: function(nextProps) {
        var props = nextProps || this.props;
        return props.existingImage || props.defaultImage || '';
    },

    getInitialState: function() {
        return { url: this._urlForState(this.props) };
    },

    componentWillReceiveProps: function (nextProps) {
        this.setState({ url: this._urlForState(nextProps) });
    },

    onUploadComplete: function(info) {
        this.setState({ url: info.cdnUrl });
        this.props.onChange(info.cdnUrl);
    },

    componentDidMount: function () {
        this.widget = window.uploadcare.Widget(this.refs.input.getDOMNode());
        this.widget.onUploadComplete(this.onUploadComplete);
    },

    previewUrl: function () {
        var isUC = this.state.url.indexOf('ucarecdn');
        return isUC > -1 ? this.state.url + '-/preview/200x200/' : this.state.url;
    },

    render: function () {
        var imgSrc = this.previewUrl();
        return <div className="image-uploader">
            {imgSrc.length > 0 && <img src={imgSrc} />}

            <input ref="input" type="hidden" data-images-only="true" />
        </div>;
    }
});

module.exports = ImageUploader;
