/*
  Mixin: adds a this.gettext() for client-side i18n via babel.js.
  You'll need to add strings to idealist/i18n/__init__.py by hand.
*/
module.exports = {
    componentWillMount: function() {
        // XXX:msb if we just bind to this event, React widgets that load
        // later will miss it; but if we load in window.gettext here when it
        // already exists, we get <span class="lateTranslate"> in places
        // we don't want it (like placeholder attrs).

        if (window.idoTranslationsAvailable) {
            this.setState({gettext: window.gettext});
        } else {
            $(document).on('translationsAvailable', function(evt, payload) {
                this.setState({gettext: payload});
            }.bind(this));
        }
    },

    gettext: function(str) {
        return _.isFunction(this.state.gettext) ? this.state.gettext(str) : str;
    },

    getInitialState: function () {
        return {};
    }
};
