/*
  Mixin:
  When mounted, become an observer of all objects
  returned by the component's observed() method.
  Goes hand-in-hand with DEF.Observable.
*/
module.exports = {
    // Maybe go through props and see which ones are Observables?
    componentDidMount: function () {
        _.invoke(this.observed(), 'addObserver', this);
    },

    componentWillUnmount: function () {
        _.invoke(this.observed(), 'removeObserver', this);
    }
};
