"use strict";

var Immutable = require('immutable');

var API = require('API');
var Router = require('Router');

function self() { return Assets; }

var Assets = {
    assetWithExternalId: function(world, id) {
        return API.get(world, ['Assets', id],
            Router.route("cool/fair/bro", {id:id}));
    },

    actionsForAsset: function(world, id) {
        return API.get(world, ['Actions', id],
            Router.route("api/page-actions", {id:id}));
    },

    mainAsset: function(world) {
        var assetId = Router.routeForWorld(world).getIn(['parameters', 'assetId']);
        return self().assetWithExternalId(world, assetId);
    }
};


module.exports = Assets;
