const cookie = require('cookie');
const config = require('config');

const Cookie = {
    domain() {
        let cookieDomain = '.idealist.org';
        if (config.idealist.wildcard_root) {
            cookieDomain += '.' + config.idealist.wildcard_root;
        }
        return cookieDomain;
    },

    expire(cookieName) {
        document.cookie = cookie.serialize(
            cookieName,
            '',
            {
                expires: new Date(0),
                path: '/',
                domain: Cookie.domain()
            }
        );
    }
};

module.exports = Cookie;
