"use strict";

var Immutable = require('immutable');

var Wish = require('Wish');
var Router = require('Router');
var API = require('API');


var InfoPages = {
    infoPageWithPath(world, path) {
        return API.get(world, ['InfoPages', 'Page', path],
            Router.route("api/v2/info", {path:path}));
    },

    routedInfoPageWithNavigation(world) {
        var path = Router.routeForWorld(world).getIn(['parameters', 'path']);
        return this.infoPageAndNavigationWithPath(world, path);
    },

    infoNavigationForPath(world, path) {
        var root = this.infoRootFromPath(path);
        return API.get(world, ['InfoPages', 'Navigation', root],
            Router.route("api/v2/info-navigation", {path}));
    },

    infoRootFromPath(path) {
        return path.replace('^\/', '').split('/')[0];
    },

    infoPageAndNavigationWithPath(world, path) {
        return Wish.seq(
            this.infoNavigationForPath(world, path),
            () => this.infoPageWithPath(world, path));
    },

    routedInfoNavigation(world) {
        var path = Router.routeForWorld(world).getIn(['parameters', 'path']);
        return this.infoNavigationForPath(world, path);
    }
};


module.exports = InfoPages;
