module.exports = {

    /* **** MOBILE **** */

    isMobileNavMenuOpen (world) {
        return world.getIn(['NavMenu', 'MobileNavMenuShown']);
    },

    toggleMobileNavMenu (world, state) {
        state = state === undefined ? !this.isMobileNavMenuOpen(world) : state;
        world.performAction({
            name: 'NavMenu/ToggleMobileNavMenu',
            transaction: (ws) => ws.setIn(['NavMenu', 'MobileNavMenuShown'], state)
        });
    },

    isApplicationSliding (world) {
        return world.getIn(['NavMenu', 'ApplicationSliding']);
    },

    toggleApplicationSlide (world, state) {
        state = state === undefined ? !this.isMobileNavMenuOpen(world) : state;
        world.performAction({
            name: 'NavMenu/ToggleApplicationSlide',
            transaction: (ws) => ws.setIn(['NavMenu', 'ApplicationSliding'], state)
        });
    },

    /* TODO:
        investigate refactoring toggleApplicationSlide & toggleMobileNavMenu into
        a state machine that walks through the following states. Any input that changes
        the state should simply increment the index into this state table, modulo 4.

          open, sliding, close
        0    f,       f,     f        initial page load
        1    t,       t,     f        click hamburger
        2    t,       f,     f        animation end
        3    f,       t,     t        click to close menu
        4    f,       f,     f        animation end

        TOFIGUREOUT: what to do about differences in openIfSliding?
    */

    // FIXME openIfSliding is a terrible thing
    slidingClassNames (world, openIfSliding) {
        var open = this.isMobileNavMenuOpen(world);
        var sliding = this.isApplicationSliding(world);

        return {
            open: open || (openIfSliding ? sliding : false),
            close: !open && sliding,
            slide: true
        };
    }
};
