"use strict";

var Wish = require('Wish');

var Retrieve = function (path) {
    return {
        name: "Plaything/Retrieve",
        transaction: (ws) => ws.setIn(path, Wish.Pending()),
        effect: (world) => world.performAction(ThingWasRetrieved(path))
    };
};

var ThingWasRetrieved = function (path) {
    return {
        name: "Plaything/ThingWasRetrieved",
        transaction: (ws) => ws.setIn(path, Wish.Available("Hello")),
    };
};

var Playthings = {
    mainPlaything: function (world) {
        return Wish.performOnce(world, ['MainPlaything'], Retrieve(['MainPlaything']));
    }
};

module.exports = Playthings;
