"use strict";

var React = require('react');

var Client = require('dealers/Client');
var World = require('World');


var Centered = React.createClass({
    mixins: [World.Child],

    getInitialState: function() {
        return {
            top: this.props.initialY || 0,
            left: this.props.initialX || 0,
            height: 0,
            width: 0,
            computed: false
        };
    },

    componentDidMount: function() {
        this.prevHeight = React.findDOMNode(this.refs.frame).scrollHeight;
    },

    prevHeight: 0,

    componentDidUpdate: function(prevProps, prevState) {
        this.prevHeight = prevState.height;
    },

    render: function() {
        var styles = {
            position: 'absolute',
            display: 'table',
            top: 0,
            left: 0,
            height: '100%',
            width: '100%',
            overflow: 'auto'
        };
        var childStyles = {
            display: 'table-cell',
            verticalAlign: 'middle',
            textAlign: 'center'
        };
        var grandChildStyles = {
            textAlign: 'initial',
            display: 'inline-block'
        };
        // parent/child table + table-cell centers vertically
        // child/grandchild text-align: center + inline-block center horizontally
        // text-align: initial resets for great-grandchildren
        return <div className="centered"
                    ref="frame"
                    style={styles}>
            <div style={childStyles}>
                <div style={grandChildStyles}>
                    {this.props.children}
                </div>
            </div>
        </div>;
    }
});

module.exports = Centered;
