"use strict";

var React = require('react');

var {I18N, i18n} = require('I18N');


var Error = React.createClass({
    render: function () {
        return (
            <div className="susify">
                <h1>{this.props.headline}</h1>
                {this.props.children}
            </div>
        );
    }
});


var Unauthorized = React.createClass({
    render: function() {
        return (
            <Error headline={i18n('Come on in!')}>
                <p><I18N>Thanks for being here. You&apos;ll need to <a i18n-id="login" href="#" onClick={this.popLogIn}>log in</a> or <a i18n-id="signup" href="#" onClick={this.popLogIn}>sign up</a> to see this page.</I18N>
                </p>
            </Error>
        );
    },

    popLogIn: function(event) {
        // FIXME: replace with the sherpa replacement
        event.preventDefault();
        FormSherpa.present('ido-signup', $('[data-role=modal]'), {modal: true});
    }
});


var Forbidden = React.createClass({
    render: function() {
        return (
            <Error headline={i18n('Uh oh!')}>
              <I18N><p>Sorry we can&apos;t show you this page right now. It may have expired or you may not have permission to view it.</p>
              <p>Would you like to <a i18n-id="back" href="#" onClick={this.goBack}>go back</a> or <a i18n-id="home" href="/">home</a> instead?</p></I18N>
            </Error>
        );
    },

    goBack: function(event) {
        event.preventDefault();
        window.history.go(-1);
    }
});


var NotFound = React.createClass({
    render: function () {
        // FIXME: this (and other errors) really should
        // return proper http response headers
        return (
            <Error headline={i18n('Oops! Resource not found')}>
                <p><I18N>Nothing is here right now.</I18N></p>
            </Error>
        );
    }
});


var UnexpectedError = React.createClass({
    render: function() {
        // FIXME: this is totally incomplete/inadequate
        return (
            <Error headline={i18n('An unexpected error occurred')}>
                {this.props.error &&
                    <I18N><p>Error code: {this.props.error.status}</p></I18N>
                }
                {this.props.children}
            </Error>
        );
    }
});


function standardHandler(error) {
    error = error.toJS();
    switch(error.status) {
    case 401:
        return <Unauthorized/>;
        break;
    case 403:
        return <Forbidden/>;
        break;
    case 404:
        return <NotFound/>;
        break;
    default:
        return <UnexpectedError error={error}/>;
    }
}

module.exports = {
    Error: Error,
    UnexpectedError: UnexpectedError,
    Unauthorized: Unauthorized,
    Forbidden: Forbidden,
    standardHandler: standardHandler
};
