"use strict";

var React = require('react/addons');

var Input = require('elements/Forms/Input');
var Validation = require('elements/Validation');
var Valid = require('abc/validators');

var FormInput = React.createClass({
    propTypes: {
        validation: React.PropTypes.object.isRequired,
        value: React.PropTypes.string
    },

    getDefaultProps() {
        return { onKeyDown: function(e) {
            if (e.key === 'Enter') {
                e.preventDefault();
                e.stopPropagation();
            }
        }};
    },

    render: function() {
        return <div className="field">
            <Input {...this.props} ref="input" />
            <Validation
                validation={this.props.validation}
                position={this.position} />
        </div>;
    },

    focus: function() {
        this.refs.input && this.refs.input.getDOMNode().focus();
    },

    componentDidUpdate: function() {
        this.position = this.refs.input.getDOMNode().offsetTop;
    }
});

module.exports = FormInput;
