import React from 'react';
import IDOPropTypes from 'IDOPropTypes';

let Form = React.createClass({
    propTypes: {
        schema: React.PropTypes.object.isRequired,
        onChange: React.PropTypes.func.isRequired,
        children: IDOPropTypes.react.children
    },

    // TODO in React 0.14:
    // childContextTypes: {
    //     schema: React.PropTypes.object,
    //     onChange: React.PropTypes.func.isRequired
    // },
    //
    // getChildContext() {
    //     return {
    //         schema: this.props.schema,
    //         onChange: this.props.onChange
    //     };
    // },

    componentWillMount() {
        this.props.schema.observe(this.props.onChange);
    },

    componentWillUnmount() {
        this.props.schema.unobserve(this.props.onChange);
    },

    render() {
        let {schema, onChange, ...props} = this.props;
        return <form {...props}>
            {this.props.children}
        </form>;
    }
});


export default Form;
