"use strict";

var React = require('react');

var IDOPropTypes = require('IDOPropTypes');

var Field = require('elements/Forms/Field');
var InputWrapper = require('elements/Forms/InputWrapper');
var ValidationMessage = require('elements/Forms/ValidationMessage');
var Validation = require('elements/Validation');


var SubField = React.createClass({
    mixins: [Field],

    propTypes: {
        value: React.PropTypes.any,
        element: React.PropTypes.object,
        label: React.PropTypes.oneOfType([
            React.PropTypes.string,
            React.PropTypes.element
        ]),
        type: React.PropTypes.oneOfType([
            React.PropTypes.string,
            React.PropTypes.func
        ]),
        validation: React.PropTypes.object,
        className: React.PropTypes.string,
        showErrors: React.PropTypes.bool
    },

    getInitialState() {
        return { errorRight: 30, errorTop: 45 };
    },

    render() {
        let schema = this.schemaElement();
        let value = schema && schema.value ? schema.value : this.props.value;
        let Input = typeof this.props.type === 'string'
            ? InputWrapper
            : this.props.type;
        return <div style={{position: 'relative'}}>
            <label>{this.props.label}</label>
            <Input {...this.props}
                ref="input"
                value={value}
                onChange={this.onChange} />
            {this.props.validation &&
                <Validation validation={this.props.validation}
                    leftPosition={30} />}
            {this.props.showErrors && this.props.element &&
                <ValidationMessage
                    topPosition={this.state.errorTop}
                    rightPosition={this.state.errorRight}
                    messages={this.props.element.errors} />}
        </div>
    },

    componentDidMount() {
        let fullBox = React.findDOMNode(this).getBoundingClientRect();
        let inputBox = React.findDOMNode(this.refs.input).getBoundingClientRect();
        let errorRight = fullBox.width - inputBox.width;
        let errorTop = inputBox.height;
        this.setState({errorRight, errorTop});
    }
});

module.exports = SubField;
