"use strict";

var React = require('react/addons');

var ValidationMessage = React.createClass({
    propTypes: {
        messages: React.PropTypes.array.isRequired,
        topPosition: React.PropTypes.number,
        rightPosition: React.PropTypes.number,
        externalWidget: React.PropTypes.bool
    },

    render() {
        var TransitionGroup = ValidationMessage.TransitionGroup;
        var style = {top: (this.props.topPosition || 0) + 20};
        if (typeof this.props.rightPosition !== 'undefined') {
            style.right = this.props.rightPosition;
        }

        return <div
                className={['error-slot', this.props.externalWidget ? 'external-widget-cushion' : null].join(' ')}
                style={style}>
            <TransitionGroup transitionName="input-error" transitionAppear={true}>
                {this.props.messages && this.props.messages.length && <div key="error" className="error-slider">
                    <div className="error-balloon">{this.props.messages.map(m => <div key={m}>{m}</div>)}</div>
                </div>}
            </TransitionGroup>
        </div>;
    }
});

// Expose for testing with mocks.
ValidationMessage.TransitionGroup = React.addons.CSSTransitionGroup;

module.exports = ValidationMessage;
