"use strict";

var React = require('react');

var {i18n} = require('I18N');

var BoxWidget = require('elements/BoxWidget');
var ItemsBrowser = require('gradfair/ItemsBrowser').ItemsBrowser;

var ExhibitorList = React.createClass({
    propTypes: {
        fair: React.PropTypes.object
    },

    render: function() {
        var exhibitors = this.props.fair.exhibitors,
            exhibitorCt = exhibitors ? exhibitors.length : 0;

        return <BoxWidget headline={exhibitorCt + ' exhibitors'}>
            <ItemsBrowser items={exhibitors || []}
                          seeAllLink={this.props.fair.actions.view_exhibitors.url}
                          emptyMessage={i18n('No exhibitors have registered.')} />
        </BoxWidget>;
    }
});
