"use strict";

var React = require('react');
var Assets = require('dealers/Assets');
var Wish = require('Wish');
var World = require('World');
var {I18N, i18n} = require('I18N');

var Look = require('elements/Look');


var PageActions = React.createClass({
    render: function() {
        var actions = this.props.actions;
        return <ul className="pageActions">
            <li>
                <button onClick={function(){location.href=actions.rsvp.url}}>
                    {actions.rsvp.is_attending ? i18n('Attending') : i18n('RSVP')}
                </button>
            </li>
            <li>
                <button onClick={function(){location.href=actions.bookmark.url}}>
                    {actions.bookmark.bookmarked ? i18n('Un-Bookmark') : i18n('Bookmark')}
                </button>
            </li>
            <li>
                <button onClick={function(){location.href+='#spread-the-word'}}>
                    <I18N>Spread the word</I18N>
                </button>
            </li>
            <li>
                <button onClick={function(){print()}}>
                    <I18N>Print</I18N>
                </button>
            </li>
        </ul>;
    }
});


var GradFairHeader = React.createClass({
    mixins: [World.Child],

    render: function() {
        var doc = this.props.fair;
        var location = '';
        if (doc.addresses && doc.addresses[0]) {
            location = doc.addresses[0].city;
        }

        // make a wish!
        var actions = Assets.actionsForAsset(this.world(), doc.external_id);

        return <header id="contentHeader">
            <h1><I18N>{location} Idealist Grad Fair</I18N></h1>
            <Look wish={actions}>{{
                Pending: function() { return <PageActions actions={doc.actions} />; },
                // FIXME: one of these 'actions' needs toJS, one doesn't. Eww.
                Available: function(actions) { return <PageActions actions={actions.toJS()} />; },
                // FIXME: error handling is not quite working
                Error: function() { return <div>ERROR: page actions not available</div>; }
            }}</Look>
        </header>;
    }
});

module.exports = GradFairHeader;
