"use strict";

var React = require('react');

var Assets = require('dealers/Assets');
var Errors = require('elements/Errors');
var Look = require('elements/Look');
var Wish = require('Wish');

var GradFairRendering = {
    statics: {
        initialWishes: function (world) {
            return [Assets.mainAsset]
        },

        htmlHead: function (world) {
            return {
                stylesheet: "gradfair",
                title: Wish.look(Assets.mainAsset(world), {
                    Pending: () => "Idealist.org",
                    Error: () => "Idealist.org",
                    Available: (asset) => asset.get('name') + " - Idealist.org"
                })
            }
        }
    },

    asset: function() {
        return Assets.mainAsset(this.world());
    },

    render: function () {
        return <Look wish={this.asset()}>{{
            Pending: function () {
                return <div>pending</div>;
            },

            Available: this.renderWhenExists,

            Error: Errors.standardHandler
        }}</Look>;
    },

    popLogIn: function(event) {
        // FIXME: replace with the sherpa replacement
        FormSherpa.present('ido-signup', $('[data-role=modal]'), {modal: true});
        event.preventDefault();
    }
};

module.exports = GradFairRendering;
