"use strict";

var React = require('react');

var config = require('config');

function stylesheetPathForStylesheetName (name) {
    var release = config.idealist.release;
    return '/@/'+release+'/ido-1/css/'+name+'.css';
}

var HtmlHead = React.createClass({
    propTypes: {
        info: React.PropTypes.shape({
            title: React.PropTypes.string
        }).isRequired
    },

    statics: {
        serverHtmlString: function (info) {
            return '<title>'+info.title+'</title>'+
            '<link rel="stylesheet" type="text/css" id="HtmlHeadStylesheet" href="'+stylesheetPathForStylesheetName(info.stylesheet)+'">';
        }
    },

    update: function (info) {
        document.title = info.title;

        // XXX We need to evaluate this and other methods of stylesheet
        // switching in different browsers.
        var stylesheetTag = document.getElementById('HtmlHeadStylesheet');
        var currentStylesheet = stylesheetTag.getAttribute('href');

        // only set the href attribute if the stylesheet has changed: it seems that
        // spamming this attribute while loading can cause visual glitches to occur
        if (currentStylesheet != stylesheetPathForStylesheetName(info.stylesheet)) {
            stylesheetTag.setAttribute("href", stylesheetPathForStylesheetName(info.stylesheet));
        }
    },

    // TODO: It would be nice to submit a patch to react-hot-loader
    // that would allow us to update when HMR occurs. And also
    // https://github.com/gaearon/react-hot-loader/issues/25

    componentDidMount: function () { this.update(this.props.info); },
    componentDidUpdate: function () { this.update(this.props.info); },
    render: function () { return null; }
});

module.exports = HtmlHead;
