"use strict";

var React = require('react');
var Immutable = require('immutable');

var Geo = require('dealers/Geo');

var World = require('World');

var GeoLocationList = require('./GeoLocationList');


var CountryList = React.createClass({
    mixins: [World.Child],

    propTypes: {
        value: React.PropTypes.number,
        onChange: React.PropTypes.func.isRequired
    },

    getInitialState: function() {
        return {
            countries: Immutable.List()
        };
    },

    componentDidMount: function() {
        Geo.getCountries(this.world().get('Locale'),
            result => this.setState({countries: result}));
    },

    render: function() {
        return <GeoLocationList value={this.props.value} options={this.state.countries} onChange={this.onChange} />
    },

    onChange: function(geoid) {
        var selected = this.state.countries.filter(val => val.geoid === geoid);
        this.props.onChange(selected.first());
    }

});

module.exports = CountryList;
