"use strict";

var React = require('react');
var IDOPropTypes = require('IDOPropTypes');

var TrapdoorSelect = require('elements/TrapdoorSelect');


var GeoLocationList = React.createClass({
    propTypes: {
        value: React.PropTypes.any,
        onChange: React.PropTypes.func.isRequired,
        options: IDOPropTypes.immutable.list
    },

    render() {
        return <TrapdoorSelect onChange={this.onChange} value={this.props.value}>
            {this.props.options.toJS().map(pair =>
                <option key={pair.geoid} value={pair.geoid}>{pair.name}</option>)}
        </TrapdoorSelect>
    },

    onChange(event) {
        // parseInt because <option> stringifies values:
        this.props.onChange(parseInt(event.target.value, 0));
    }
});

module.exports = GeoLocationList;
