"use strict";

var React = require('react');
var IDOPropTypes = require('IDOPropTypes');
var Immutable = require('immutable');

var Autocomplete = require('elements/Autocomplete');
var Validation = require('elements/Validation');
var ValidationMessage = require('elements/Forms/ValidationMessage');


var LocationTypeahead = React.createClass({
    propTypes: {
        element: React.PropTypes.object,
        value: React.PropTypes.string.isRequired,
        onInput: React.PropTypes.func.isRequired,
        onFocusOption: React.PropTypes.func,
        onSelect: React.PropTypes.func.isRequired,
        options: IDOPropTypes.immutable.list.isRequired,

        placeholder: React.PropTypes.string,
        tabIndex: React.PropTypes.string,
        onBlur: React.PropTypes.func,
        maxMenuHeight: React.PropTypes.number,
        validation: IDOPropTypes.immutable
    },

    render() {
        var typeaheadOpts = this.props.options.map(
            place => <Autocomplete.Option key={place.get('geoid')}
                        value={place.get('matched_name')}>
                            {place.get('matched_name')}
                       </Autocomplete.Option>
        ).toJS();
        return <div>
            <Autocomplete.Combobox
                ref='source'
                placeholder={this.props.placeholder}
                value={this.props.value}
                autocomplete='list'
                tabIndex={this.props.tabIndex}
                onInput={this.props.onInput}
                onBlur={this.props.onBlur}
                maxMenuHeight={this.props.maxMenuHeight}
                onFocusOption={this.props.onFocusOption}
                onSelect={this.props.onSelect}>
                {typeaheadOpts}
            </Autocomplete.Combobox>
            {this.props.validation &&
                <Validation validation={this.props.validation} position={this.props.position} />}
            {this.props.showErrors && this.props.element &&
                <ValidationMessage
                    topPosition={37} // trollface emoji
                    messages={this.props.element.members.geoid.errors} />}
        </div>
    },
});

module.exports = LocationTypeahead;
