var React = require('react');

var Auth = require('dealers/Auth');
var Wish = require('Wish');
var World = require('World');
var {I18N} = require('I18N');

var Link = require('elements/Link');
var Look = require('elements/Look');
var Spinner = require('elements/Spinner');


var ForgotPassword = React.createClass({
    mixins: [World.Child],

    propTypes: {
        email: React.PropTypes.string.isRequired,
        onRequestSent: React.PropTypes.func.isRequired
    },

    getDefaultProps () {
        return {onRequestSent: () => {}};
    },

    render() {
        var email = this.props.email;
        var request = Auth.existingResetRequestForEmail(this.world(), email);
        var child = <p style={{marginBottom: 0}}><a href="#" onClick={this.requestPasswordReset}><I18N>Forgot your password?</I18N></a></p>;
        if (request) {
            child = <Look wish={Auth.requestPasswordResetForEmail(this.world(), email)}>
                {{
                    Pending: () => <Spinner />,
                    Available: () => <p style={{marginBottom: 0}} className="pane-warning" role="alert">
                        <I18N>A password reminder request was sent to {email}. Didn't get it? <Link endpoint="contact-us">Contact us</Link>.</I18N>
                    </p>,
                    Error: () => <span><I18N>Something went wrong. Please <a i18n-id="try" href="#" onClick={this.requestPasswordReset}>try again</a>.</I18N></span>
                }}
            </Look>;
        }
        return <div style={{marginTop: -10, minHeight: 60}}>{child}</div>;
    },

    requestPasswordReset(event) {
        Auth.requestPasswordResetForEmail(this.world(), this.props.email);
        this.props.onRequestSent();
        event.preventDefault();
    }
});


module.exports = ForgotPassword;
