"use strict";

var React = require('react/addons');
var _ = require('underscore');

var {I18N, i18n} = require('I18N');

var Signin = require('dealers/Signin');

var FormInput = require('elements/FormInput');
var LocationField = require('elements/LocationField');


var NameLocView = React.createClass({
    render: function() {
        return <div>
            {!this.props.inline && <div>
                <h3><I18N>Create your account</I18N></h3>
                <p><I18N>Looks like you're new here. Sign up!
                Or, <a i18n-id="login" onClick={this.props.goBack} href="#">log in</a> with a different email.</I18N></p>
            </div>}
            {this.props.inline && <div className="field">
                <label><I18N>Email</I18N></label>
                <FormInput type="email" ref="emailAddress" name="email"
                    value={this.props.email}
                    onChange={Signin.changeHandlerFor('email')}
                    onFocus={this.props.hideFieldValidation('email')}
                    validation={this.props.emailValidation} />
            </div>}
            <div className="field">
                <label><I18N>Full Name</I18N></label>
                <FormInput type="text" ref="full_name" name="full_name"
                    value={this.props.fullName}
                    placeholder={i18n('Enter your full name')}
                    onChange={Signin.changeHandlerFor('full_name')}
                    onFocus={this.props.hideFieldValidation('full_name')}
                    validation={this.props.fullNameValidation} />
            </div>
            <div className="field">
                <label><I18N>What should we call you?</I18N></label>
                <FormInput type="text" ref="first_name" name="first_name"
                    value={this.props.firstName}
                    placeholder={i18n('e.g. first name or nickname')}
                    onChange={Signin.changeHandlerFor('first_name')}
                    onFocus={this.props.hideFieldValidation('first_name')}
                    validation={this.props.firstNameValidation} />
            </div>
            <div className="field">
                <label><I18N>Location</I18N></label>
                <LocationField value={this.props.location}
                    autocompleteEndpointOptions={{type: 'place'}}
                    onChange={this.props.changeLocation}
                    placeholder={i18n('Enter your location - City, State, Country')}
                    onKeyUp={this.props.keyAdvance}
                    onFocus={this.props.hideFieldValidation('location')}
                    validation={this.props.locationValidation} />
            </div>
        </div>;
    },

    isValid: () => true, // we don't have any extra fields to consider

    componentDidMount: function() {
        this.refs.full_name.focus();
    }
});

module.exports = NameLocView;
