'use strict';

var React = require('react');

var World = require('World');

var Spinner = require('elements/Spinner');

/*
usage:
<Look wish={Signin.someWishIDunno()}>
    {{
        Pending: () => <Spinner />,
        Available: (data) => <div>{data}</div>,
        Error: () => <span>:-(</span>
    }}
</Look>
*/
var Look = React.createClass({
    mixins: [World.Child],

    propTypes: {
        // if you've already got the wish value, or are calling something that
        // returns one (that's most methods that involve wishes), put it here.
        wish: React.PropTypes.object,

        // in the absence of a `wish` prop, it'll try to pull a wish object out
        // of the world at a path that you specify.
        path: React.PropTypes.arrayOf(React.PropTypes.string),

        // this is the same shape of branches that you're used to. only one of
        // them will be called on a given rendering go-round.
        children: React.PropTypes.shape({
            Pending: React.PropTypes.func,
            Available: React.PropTypes.func,
            Error: React.PropTypes.func
        }).isRequired
    },

    render: function() {
        var path, wish;
        if (typeof this.props.wish !== 'undefined') {
            wish = this.props.wish;
        } else if (typeof this.props.path !== 'undefined') {
            path = this.props.path.toJS ? this.props.path.toJS() : this.props.path;
            wish = this.world().getIn(path);
        } else {
            throw new Error("<Look> received neither wish nor path");
        }
        var state = wish.get('state');
        var value = wish.get('value');

        return this.props.children[state].call(null, value);
    }
});


/*
Just takes the func you'd put under Available as the sole child, and uses a Spinner
for Pending and nothing for Error. This could be improved on those fronts but is
still handy.
*/
Look.Quick = React.createClass({
    propTypes: {
        wish: React.PropTypes.object,
        path: React.PropTypes.arrayOf(React.PropTypes.string),
        children: React.PropTypes.func.isRequired
    },

    render() {
        return <Look {...this.props}>
            {{
                Available: this.props.children || (() => null),
                Pending: () => <Spinner />,
                Error: () => null
            }}
        </Look>;
    }
});

module.exports = Look;
