// A form element to select a type of organization.

"use strict";

var React = require('react');
var Org = require('schemas/Org');
var {I18N, i18n} = require('I18N');
var _ = require('underscore');

var OrgTypeInput = React.createClass({

    propTypes: {
        // Key matching the current org type ('nonprofit', 'recruiter', etc)
        value: React.PropTypes.string.isRequired,

        // Function taking a key string for the selected org type
        onChange: React.PropTypes.func
    },

    render() {
        return <div>
            <div className="styled-select">
                <select value={this.props.value}
                               onChange={this.doChg}>
                    {_.map(Org.TYPES(), (label, intRep) =>
                        <option key={intRep} value={intRep}>{label}</option>
                    )}
                </select>
            </div>
            <p id="are-we-eligible" className="in-form-link">
                <I18N>
                    <a href="/info/Help/Organizations#Eligibility">Are we eligible?</a>
                </I18N>
            </p>
        </div>;
    },

    doChg(evt) {
        this.props.onChange(evt.target.value);
    }

});

module.exports = OrgTypeInput;
