// Load remote scripts asynchronously on the client.

"use strict";

var React = require('react');
var World = require('World');
var API = require('API');
var Spinner = require('elements/Spinner');

var ScriptPreLoader = React.createClass({
    mixins: [World.Child],

    propTypes: {
        showSpinner: React.PropTypes.bool,
        children: React.PropTypes.oneOfType([
            React.PropTypes.arrayOf(React.PropTypes.node),
            React.PropTypes.node
        ])
    },

    getInitialState() {
        return {
            scriptsLoaded: false
        };
    },

    // TODO: the preloading should be a function passed in as a prop.
    // also it's possible that ScriptPreLoader would be better as a component
    // decorator/HOC thing, so you could export components with script dependencies
    // as a unit, rather than having implicit dependencies as we do here.
    componentDidMount() {
        API.constants(this.world(), 'restrictiveRTE', 'areaOfFocus');

        // Keep uploadcare from spamming document.documentElement attributes
        global.UPLOADCARE_MANUAL_START = true;

        // Wait to load scriptjs until we are on the client because it is not
        // isomorphic.
        var $script = require('scriptjs');

        var jquery = '//code.jquery.com/jquery-1.8.3.min.js';
        var uc = '//ucarecdn.com/widget/2.5.5/uploadcare/uploadcare.min.js';
        var wysi = '/javascript/src/vendor/forks/wysihtml5-0.4.0pre.ido.js';
        var jqui = '/javascript/src/vendor/ui-1.8.23/jquery-ui-1.8.23.custom.js';

        $script([jquery, wysi], 'stage1');
        $script.ready('stage1', () => {
            $script([jqui, uc], 'stage2');
        });
        $script.ready('stage2', this.onScriptsLoaded);
    },

    onScriptsLoaded() {
        this.setState({scriptsLoaded: true});
    },

    render() {
        return this.state.scriptsLoaded
             ? this.props.children
             : (this.props.showSpinner ? <Spinner/> : null);
    }
});

module.exports = ScriptPreLoader;
