"use strict";

var React = require('react/addons');
var Link = require('elements/Link');
var {I18N, i18n} = require('I18N');


function capitalize (str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
}

var AssetSearch = React.createClass({
    render: function () {
        var className = "searchLinkForAssetType" + capitalize(this.props.type);
        return <Link endpoint="search" values={{search_type: this.props.type, csrc: 'header'}} className={className}>
            {this.props.children}
        </Link>;
    }
});

var PageHeaderAssetSearches = React.createClass({
    render: function() {
        return <div className="assetSearches">
            <span className="group">
                <AssetSearch type="job"><I18N>Jobs</I18N></AssetSearch>
                <AssetSearch type="internship"><I18N>Internships</I18N></AssetSearch>
            </span>
            <span className="group">
                <AssetSearch type="volop"><I18N>Volunteer</I18N></AssetSearch>
                <Link endpoint="act" className="action"><I18N>Action</I18N></Link>
                <AssetSearch type="event"><I18N>Events</I18N></AssetSearch>
            </span>
            <span className="group">
                <AssetSearch type="org"><I18N>Organizations</I18N></AssetSearch>
            </span>
        </div>;
    }
});

module.exports = PageHeaderAssetSearches;
