"use strict";

var React = require('react/addons');

var LoginSignup = require('dealers/LoginSignup');
var Router = require('Router');
var World = require('World');
var {I18N, i18n} = require('I18N');

var If = require('abc/if');
var LocationField = require('elements/LocationField');
var PopupMenu = require('abc/popup_menu');
var Input = require('elements/Forms/Input');


// TODO: refactor these to share code, rename file to e.g. Search.jsx
var PageHeaderSearch = React.createClass({
    mixins: [World.Child],

    getInitialState: function() {
        return { lastLocationResult: '' };
    },

    openSignup: function() {
        LoginSignup.openSignup(this.world());
    },

    render: function () {
        var actionUrl = Router.urlForRoute(Router.route('search'));
        var isStaff = false;
        var thisJustSaysOr = " " + i18n('or') + " ";
        return <div id="searchBox" className={isStaff ? 'staff' : ''} role="search">
            <form name="search_form" action={actionUrl} method="post" className="site-search">
                <input type="hidden" id="search_qs" name="qs" />
                <input type="hidden" id="search_language" name="search_language" value="en" />
                <input type="hidden" id="search_location_language" name="search_location_language" value="en" />
                <If test={isStaff}>
                    <input type="hidden" id="search_staff" name="search_staff" value={true} />
                </If>
                <div className="styled-select" tabIndex="2">
                    <select name="search_type" id="searchOptions">
                        <option value=""><I18N>All types</I18N></option>
                        <option value="job"><I18N>Jobs</I18N></option>
                        <option value="internship"><I18N>Internships</I18N></option>
                        <option value="volop"><I18N>Volunteer Opps</I18N></option>
                        <option value="actionop"><I18N>Action Opps</I18N></option>
                        <option value="user"><I18N>People</I18N></option>
                        <option value="org"><I18N>Organizations</I18N></option>
                        <option value="event"><I18N>Events</I18N></option>
                        <option value="feature"><I18N>Blogs</I18N></option>
                    </select>
                </div>
                <Input name="search_user_query" placeholder={i18n('What?')} type="text" tabIndex="3" className="text" data-clearable="true" />

                <LocationField placeholder={i18n('Where?')}
                    tabIndex="4"
                    value={LocationField.blankLocation({location: this.state.lastLocationResult})}
                    onChange={map => this.setState({lastLocationResult: map.get('location')})}
                    onKeyUp={evt => this.setState({lastLocationResult: evt.target.value})}
                    allowFallback={false} />
                  <input type="hidden" id="search_location_name" name="search_location_name" value={this.state.lastLocationResult} />

                <div id="searchButtonContainer">
                    <div id="savedSearches" className="saved-searches delayedHover dropList" data-triggers-on="#ssExpando">
                        <div className="current">
                            <button type="submit" tabIndex="5" id="searchButton" className="button search left"><I18N>Search</I18N></button>
                            <PopupMenu className="saved-search-menu"
                               trigger={<a href="" id="ssExpando" className="search button right">
                                            <span className="expando-arrow">&nbsp;</span>
                                        </a>}>
                                <dl>
                                    <dt className="dropListItem anon">
                                        <I18N>Save your favorite searches.
                                        <br />
                                        <a i18n-id="login" href="#" onClick={this.openSignup}>Log in</a>
                                        {thisJustSaysOr /* damn automagic react whitespace compression */}
                                        <a i18n-id="signup" href="#" id="signup_link" onClick={this.openSignup}>sign up</a>!</I18N>
                                    </dt>
                                </dl>
                                <a className="dropListItem advancedSearch" href="/search/v2/advanced"><I18N>Advanced search</I18N></a>
                            </PopupMenu>
                        </div>
                    </div>
                </div>
            </form>
        </div>;
    }
});


var PageFooterSearch = React.createClass({
    getInitialState: function() {
        return { lastLocationResult: '' };
    },

    render: function () {
        var actionUrl = Router.urlForRoute(Router.route('search'));
        var isStaff = false;
        return <div id="footer-search" className={isStaff ? 'staff' : ''} role="search">
            <h1 className="search-message"><I18N>Search Idealist</I18N></h1>
            <form name="search_form" action={actionUrl} method="post" className="main-site-search">
                <input type="hidden" id="search_qs" name="qs" />
                <input type="hidden" id="search_language" name="search_language" value="en" />
                <input type="hidden" id="search_location_language" name="search_location_language" value="en" />
                <If test={isStaff}>
                    <input type="hidden" id="search_staff" name="search_staff" value={true} />
                </If>
                <div className="styled-select" tabIndex="2">
                    <select name="search_type" id="searchOptions">
                        <option value=""><I18N>All types</I18N></option>
                        <option value="job"><I18N>Jobs</I18N></option>
                        <option value="internship"><I18N>Internships</I18N></option>
                        <option value="volop"><I18N>Volunteer Opps</I18N></option>
                        <option value="actionop"><I18N>Action Opps</I18N></option>
                        <option value="user"><I18N>People</I18N></option>
                        <option value="org"><I18N>Organizations</I18N></option>
                        <option value="event"><I18N>Events</I18N></option>
                        <option value="feature"><I18N>Blogs</I18N></option>
                    </select>
                </div>

                <Input name="search_user_query" placeholder={i18n('Keyword, skill, or interest')} type="text" tabIndex="3" className="text search-user-query" />

                <LocationField placeholder={i18n('Where?')} className="search-location-name"
                    value={LocationField.blankLocation({location: this.state.lastLocationResult})}
                    onChange={map => this.setState({lastLocationResult: map.get('location')})}
                    allowFallback={false}
                    tabIndex="4" />
                  <input type="hidden" id="search_location_name" name="search_location_name" value={this.state.lastLocationResult} />

                <button type="submit" tabIndex="5" className="search button"><I18N>Search</I18N></button>
            </form>

            <hr id="footer-more" />
        </div>;
    }
});


module.exports = {PageHeaderSearch, PageFooterSearch};
