"use strict";

var _ = require('underscore');
var React = require('react/addons');
var classNames = require('classnames');

var Client = require('dealers/Client');
var NavMenu = require('dealers/NavMenu');
var World = require('World');

var PageHeader = require('./PageHeader');
var PageFooter = require('./PageFooter');
var MobileNavMenu = require('./MobileNavMenu');


var PageWrapper = React.createClass({
    mixins: [World.Child],

    render: function() {
        return <div id="root">
            <PageHeader />
            {Client.isMobile(this.world()) && <MobileNavMenu />}
            <main role="main" className={classNames(NavMenu.slidingClassNames(this.world()))}>
                {this.props.children}
            </main>
            <div id="root-footer"></div>
        </div>;
    }
});

module.exports = PageWrapper;
