"use strict";

var _ = require('underscore');
var React = require('react/addons');


var ResizeWatcher = React.createClass({
    propTypes: {
        onResize: React.PropTypes.func
    },

    componentDidMount: function() {
        if (window.attachEvent) {
            window.attachEvent('onresize', this.handleResize);
        } else {
            window.addEventListener('resize', this.handleResize);
            window.addEventListener('orientationchange', this.handleResize);
        }
        this.handleResize();
    },

    componentWillUnmount: function() {
        if (window.detachEvent) {
            window.detachEvent('onresize', this.handleResize);
        } else {
            window.removeEventListener('resize', this.handleResize);
            window.removeEventListener('orientationchange', this.handleResize);
        }
    },

    handleResize: _.debounce(function() {
        this.props.onResize(this.getWindowDimensions());
    }, 100),

    getWindowDimensions: function() {
        if (window.innerHeight) {
            return {
                height: window.innerHeight,
                width: window.innerWidth
            };
        }
        return {
            height: document.documentElement.clientHeight,
            width: document.documentElement.clientWidth
        };
    },

    render: function() { 
        return null; 
    }
});

module.exports = ResizeWatcher;
