"use strict";

var React = require("react");
var _ = require("underscore");
var IDOPropTypes = require("IDOPropTypes");

/*
    A <select> that displays a '-' option when its value is undefined,
    but once you select an option, the '-' disappears and you can't go back.
    If there are no options, it becomes disabled and shows '-'.
*/
var TrapdoorSelect = React.createClass({
    propTypes: {
        value: React.PropTypes.any,
        children: IDOPropTypes.react.children
    },

    render: function () {
        var isEmpty = React.Children.count(this.props.children) === 0;
        var selectProps = _.extend({}, this.props, isEmpty ? {disabled: true} :  {});
        return <select {...selectProps}>
            {this.props.value === undefined
                ? <option key={undefined} value={undefined}>-</option>
                : null}
            {this.props.children}
        </select>;
    }
});

module.exports = TrapdoorSelect;
