var React = require('react/addons');
var _ = require('underscore');

var Validation = React.createClass({
    propTypes: {
        validation: React.PropTypes.object.isRequired,
        value: React.PropTypes.any,
        position: React.PropTypes.number,
        leftPosition: React.PropTypes.number
    },

    isValid: function() {
        return this.props.validation.ok;
    },

    render: function() {
        var TransitionGroup = React.addons.CSSTransitionGroup;

        var errorText = this.props.validation.errorMsg;
        if (_.isArray(errorText)) {
            errorText = _.reduce(errorText,(arr, msg, ind) => {
                if (ind > 0) {
                    arr.push(<br />);
                }
                arr.push(msg);
                return arr;
            }, []);
        }

        var style = {top: (this.props.position || 0) + 20};
        if (typeof this.props.leftPosition !== 'undefined') {
            style.right = 'inherit';
            style.left = this.props.leftPosition;
        }

        return <div className="error-slot" style={style}>
            <TransitionGroup component="div" transitionName="input-error">
                {this.isValid() ? null :
                    <div key="error" className="error-slider">
                        <div className="error-balloon">{errorText}</div>
                    </div>}
            </TransitionGroup>
        </div>;
    }
});

module.exports = Validation;
