"use strict";

var React = require('react');

var Link = require('elements/Link');
var BoxWidget = require('elements/BoxWidget');

var ExhibitorList = require('elements/GradFairs/ExhibitorList');
var GradFairDetails = require('elements/GradFairs/GradFairDetails');
var GradFairHeader = require('elements/GradFairs/GradFairHeader');
var GradFairRendering = require('elements/GradFairs/GradFairRendering');
var SpreadTheWord = require('elements/GradFairs/SpreadTheWord');

var ViewGradFairAsAttendee = React.createClass({
    mixins: [GradFairRendering],

    renderWhenExists: function (asset) {
        var doc = asset.toJS();

        return <div className="susify view-gradfair">
            <section className="left-column">
                <BoxWidget headline="Actions on this page">
                    <ul className="publicActions">
                        <li><Link endpoint="view/fair" values={{id: doc.external_id, exhibitor: true}}>
                            Information for Exhibitors
                        </Link></li>
                    </ul>
                </BoxWidget>
            </section>

            <div>
                <GradFairHeader fair={doc} />

                <section className="gf-content">
                    <BoxWidget headline="Hosted by"
                        staticFill={doc.hosts_and_partners} />

                    <BoxWidget headline="Fair description"
                        staticFill={doc.description} />

                    <ExhibitorList fair={doc} />

                    <If test={doc.instructions && doc.instructions.length}>
                        <BoxWidget headline="Tips to help you prepare"
                            staticFill={doc.instructions} />
                    </If>

                    <SpreadTheWord message={doc.spreadTheWord} />
                </section>

                <aside>
                    <GradFairDetails fair={doc} />
                </aside>
            </div>

        </div>;
    }
});

module.exports = ViewGradFairAsAttendee;
