"use strict";

var React = require('react');

var Link = require('elements/Link');
var BoxWidget = require('elements/BoxWidget');
var ContentGroup = require('elements/ContentGroup');

var GradFairDetails = require('elements/GradFairs/GradFairDetails');
var GradFairHeader = require('elements/GradFairs/GradFairHeader');
var GradFairRendering = require('elements/GradFairs/GradFairRendering');
var SpreadTheWord = require('elements/GradFairs/SpreadTheWord');

var ViewGradFairAsExhibitor = React.createClass({
    mixins: [GradFairRendering],

    renderWhenExists: function (asset) {
        var doc = asset.toJS();

        return <div className="susify view-gradfair">
            <section className="left-column">
                <BoxWidget headline="Actions on this page">
                    <ul className="publicActions">
                        <li><Link endpoint="view/fair" values={{id: doc.external_id}}>
                            Information for Attendees
                        </Link></li>
                    </ul>
                </BoxWidget>
            </section>

            <div>
                <GradFairHeader fair={doc} />

                <section className="gf-content">
                    <BoxWidget headline="Hosted By"
                        staticFill={doc.hosts_and_partners}>
                    </BoxWidget>

                    <If test={doc.exhibitor_description && doc.exhibitor_description.length}>
                        <BoxWidget headline="Description"
                            staticFill={doc.exhibitor_description} />
                    </If>

                    <If test={doc.how_to_register && doc.how_to_register.length}>
                        <BoxWidget headline="How to register"
                            staticFill={doc.how_to_register} />
                    </If>

                    <If test={doc.reminders_for_exhibitors && doc.reminders_for_exhibitors.length}>
                        <BoxWidget headline="Reminders"
                            staticFill={doc.reminders_for_exhibitors} />
                    </If>

                    <If test={doc.shipping && doc.shipping.length}>
                        <BoxWidget headline="Sending materials"
                            staticFill={doc.shipping} />
                    </If>

                    <SpreadTheWord message={doc.spread_the_word} />
                </section>

                <aside>
                    <GradFairDetails fair={doc}>
                        <If test={doc.exhibitor_price}>
                            <ContentGroup headline="Registration">
                                <p>Exhibitor fee: ${doc.exhibitor_price}</p>
                            </ContentGroup>
                        </If>
                    </GradFairDetails>
                </aside>
            </div>

        </div>;
    }
});

module.exports = ViewGradFairAsExhibitor;
