/*eslint camelcase: 0*/ // for IDO_i5_world_do_not_use_this

var React = require('react/addons');
var TU = React.addons.TestUtils;
var ReactContext = require('react/lib/ReactContext');

var World = require('World');

// Extend React's TestUtils with our own sauce
var TestUtils = module.exports = Object.assign({}, TU, {
    renderWithWorld(Component, props = {}, worldState = {}) {
        var world = this.world = new World(worldState);
        var SimEarth = React.createClass({
            childContextTypes: {
                IDO_i5_world_do_not_use_this: React.PropTypes.object.isRequired
            },

            componentDidMount() {
                world.onActionPerformed(this.forceUpdate.bind(this));
            },

            getChildContext() {
                return {IDO_i5_world_do_not_use_this: world};
            },

            render() {
                return <div>
                    <Component ref="component" {...props} />
                </div>;
            }
        });
        var simEarth = TU.renderIntoDocument(<SimEarth><Component ref="component" {...props} /></SimEarth>);
        return simEarth.refs.component;
    },

    renderShallowWithWorld(Component, props = {}, worldState = {}) {
        var world = this.world = new World(worldState);
        var renderer = TU.createRenderer();
        ReactContext.context = {IDO_i5_world_do_not_use_this: world};
        renderer.render(<Component {...props} />);
        ReactContext.context = {};
        return renderer.getRenderOutput();
    },

    scryRenderedDOMComponentsWithClassNames(tree, desiredClassNames) {
        return TU.findAllInRenderedTree(tree, component => hasClassNames(component, desiredClassNames));
    },

    findRenderedDOMComponentWithClassNames(tree, desiredClassNames) {
        var result = TU.findAllInRenderedTree(tree, component => hasClassNames(component, desiredClassNames));
        if (result.length !== 1) {
            throw new Error("Found " + result.length + " components with classNames " + desiredClassNames);
        }
        return result[0];
    },

    scryRenderedComponentsWithTypeAndProps(tree, type, props) {
        return TU.scryRenderedComponentsWithType(tree, type).filter(component => {
            return Object.keys(props).reduce((match, name) => {
                return match && component.props[name] === props[name];
            }, true);
        });
    },

    findRenderedComponentWithTypeAndProps(tree, type, props) {
        var components = TestUtils.scryRenderedComponentsWithTypeAndProps(tree, type, props);
        if (components.length === 0 || components.length > 1) {
            throw new Error(
                'Found ' + components.length +
                ' components of type ' + type.displayName + ' with props ' +
                JSON.stringify(props)
            );
        }
        return components[0];
    },

    asyncAssert(assertions, done) {
        setTimeout(() => {
            try {
                assertions();
                done();
            } catch (e) {
                done(e);
            }
        }, 1);
    }
});


function hasClassNames(component, desiredClassNames) {
    var classNames = (component.props.className || '').split(/\s+/);
    return desiredClassNames.every(cn => classNames.indexOf(cn) !== -1);
}
